import { Api } from '@bravobit/bb-foundation/api';
export interface AuthProvider {
    authenticate(api: Api): Promise<AuthProviderResponse>;
}
export interface AuthProviderResponse {
    user?: any;
    provider?: string;
    verifyToken?: string;
    accessToken?: string;
    refreshToken?: string;
}
export interface AuthSignInResponse {
    user?: unknown;
    provider?: string;
    verifyToken?: string;
}
