import { EventEmitter, OnInit } from '@angular/core';
import { ElementsError } from '../elements.interfaces';
import { BbFormSubmit } from '../directives/form-submit.directive';
import { NgControl } from '@angular/forms';
import { Observable } from 'rxjs';
export declare class BbFormError implements OnInit {
    private _form;
    private _control;
    private _errors;
    set control(value: NgControl);
    get control(): NgControl;
    errorChange: EventEmitter<{
        token: string;
        data?: any;
    }>;
    error$: Observable<{
        token: string;
        data?: any;
    } | null>;
    private _ngControl;
    constructor(_form: BbFormSubmit, _control: NgControl, _errors: ElementsError[]);
    ngOnInit(): void;
    private getError;
    private submitStatusChanges;
    private statusChanges;
}
