export declare const LOCALIZATION_EXTRA_ENGLISH: {
    provide: import("@angular/core").InjectionToken<import("../interfaces/dictionary.interfaces").LocalizeExtraDictionary[]>;
    useValue: {
        locale: string;
        data: {
            'form-control-errors': {
                unknown: string;
                required: string;
                pattern: string;
                email: string;
                emailTaken: string;
                passwordMatch: string;
                confirm: string;
                fullNumber: string;
                min: string;
                max: string;
                invalidFileType: string;
                maxFileSize: string;
                minlength: string;
                maxlength: string;
            };
            tables: {
                search: string;
                loading: string;
                empty: string;
                page: string;
                error_datasource: string;
                error_unauthorized: string;
                error_forbidden: string;
                error_not_found: string;
                error_server: string;
                error_unknown: string;
            };
            'file-picker': {
                choose: string;
                remove: string;
                drop: string;
            };
            times: {
                tomorrow_at: string;
                today_at: string;
                yesterday_at: string;
            };
        };
    };
    multi: boolean;
};
