import { ApiMapperProtocol } from './interfaces/mapper.interface';
import { ApiPageRequest } from './interfaces/pages.interface';
export declare class ApiMapper implements ApiMapperProtocol {
    toPageResponse<T = any>(data: any): {
        pageSize: number;
        pageNumber: number;
        totalPages: number;
        totalEntries: number;
        data: T[];
    };
    toPageRequest(data: Partial<ApiPageRequest>): {};
}
