import { HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { AuthConfig } from './interfaces/config.interface';
import { BehaviorSubject } from 'rxjs';
import { Router } from '@angular/router';
import { Auth } from './auth.service';
export declare class AuthInterceptor implements HttpInterceptor {
    private _auth;
    private _router;
    private _config;
    isRefreshing: boolean;
    token$: BehaviorSubject<string>;
    constructor(_auth: Auth, _router: Router, _config: AuthConfig);
    intercept(request: HttpRequest<any>, next: HttpHandler): import("rxjs").Observable<import("@angular/common/http").HttpEvent<any>>;
    private handle401Error;
    private logoutUser;
    private getToken;
    private composeRequest;
}
