import { ElementRef, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
import { FormGroupDirective } from '@angular/forms';
export declare class BbFormSubmit implements OnInit {
    private _host;
    private _formDirective;
    submitStatus$: Observable<boolean>;
    constructor(_host: ElementRef<HTMLFormElement>, _formDirective: FormGroupDirective);
    ngOnInit(): void;
    submit(): void;
    reset(): void;
    private get nativeElement();
    private reactiveSubmitChanges;
}
